Index: src/isdn/Q921.c
===================================================================
--- src/isdn/Q921.c	(revision 495)
+++ src/isdn/Q921.c	(working copy)
@@ -479,80 +2449,577 @@
 *****************************************************************************/
 int Q921Rx12(L2TRUNK trunk)
 {
-    L2UCHAR *mes;
-    L2INT rs,size;     /* receive size & Q921 frame size*/
+	L2INT size;     /* receive size & Q921 frame size*/
     L2UCHAR *smes = MFIFOGetMesPtr(trunk->HDLCInQueue, &size);
-	L2UCHAR nr;
 
-    if(smes != NULL)
+	if(smes)
     {
+		L2UCHAR sapi, tei;
+		L2UCHAR *mes;
+		L2INT rs;
+
         rs = size - trunk->Q921HeaderSpace;
         mes = &smes[trunk->Q921HeaderSpace];
 
-		if ((mes[2] & 3) != 3) {
-			/* we have an S or I frame */
-			/* if nr is between va and vs, update our va counter */
-			nr = (mes[3] >> 1);
-			if (nr >= trunk->va && nr <= trunk->vs) {
-				trunk->va = nr;
+		Q921LogMesg(trunk, Q921_LOG_DEBUG, 1, mes, rs, "New packet received (%d bytes)", rs);
+
+		/* common fields: get sapi, tei and cr */
+		sapi = (mes[0] & 0xfc) >> 2;
+		tei  = (mes[1] & 0xfe) >> 1;
+
+		if(Q921_IS_PTMP_TE(trunk) && (
+			 (trunk->state >= Q921_STATE_TEI_ASSIGNED && tei != trunk->tei && tei != Q921_TEI_BCAST) ||		/* Assigned TEI: Only BCAST and directed */
+			 (trunk->state == Q921_STATE_TEI_UNASSIGNED && tei != Q921_TEI_BCAST)))					/* No assigned TEI: Only BCAST */
+		{
+			/* Ignore Messages with foreign TEIs */
+			Q921Log(trunk, Q921_LOG_DEBUG, "Ignoring incoming frame for non-local/-broadcast TEI\n");
+			goto out;
 			}
+
+		switch(mes[2] & 0x03) {
+		case 0x00:	/* I frame */
+			Q921ProcIFrame(trunk, mes, rs);
+			break;
+
+		case 0x01:	/* S frame */
+			Q921ProcSFrame(trunk, mes, rs);
+			break;
+
+		case 0x03:	/* U frame */
+			Q921ProcUFrame(trunk, mes, rs);
+			break;
+
+		default:
+			Q921Log(trunk, Q921_LOG_ERROR, "Invalid frame type: %d\n", (int)(mes[2] & 0x03));
+			/* TODO: send FRMR or REJ */
+		}
+
+out:
+		MFIFOKillNext(trunk->HDLCInQueue);
+
+		return 1;
 		}
 
-        /* check for I frame */
-        if((mes[2] & 0x01) == 0)
+	return 0;
+}
+
+/*
+ * Misc
+ */
+
+/**
+ * Q921SetLogCB
+ * \brief	Set logging callback
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	func	pointer to logging callback function
+ * \param[in]	priv	pointer to private data
+ *
+ * \author	Stefan Knoblich
+ */
+void Q921SetLogCB(L2TRUNK trunk, Q921LogCB_t func, void *priv)
         {
+	if(!trunk)
+		return;
+
+	trunk->Q921LogProc = func;
+	trunk->PrivateDataLog = priv;
+}
 
-			/* we increment before we "really" know its good so that if we send in the callback, we use the right nr */
-			trunk->vr++;
-            if(Q921Tx23Proc(trunk, smes, size-2)) /* -2 to clip away CRC */
+/**
+ * Q921SetLogLevel
+ * \brief	Set loglevel of Q.921 logging functions
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	level	new loglevel
+ *
+ * \author	Stefan Knoblich
+ */
+void Q921SetLogLevel(L2TRUNK trunk, Q921LogLevel_t level)
             {
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[3]&0x01);
+	if(!trunk)
+		return;
+
+	trunk->loglevel = level;
 			}
-            else
+
+
+/**
+ * Q921ChangeState
+ * \brief	Change state, invoke neccessary actions
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	state	state to change to
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921ChangeState(L2TRUNK trunk, Q921State_t state)
             {
-                /* todo: whatever*/
-				/* trunk->vr--; */
-				/* for now, lets just respond for easier debugging on errors */
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[3]&0x01);
+	Q921State_t oldstate = trunk->state;
+	int res = 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Changing state from \"%s\" (%d) to \"%s\" (%d)\n",
+				Q921State2Name(oldstate), oldstate,
+				Q921State2Name(state), state);
+
+	switch(oldstate) {
+	case Q921_STATE_STOPPED:
+
+		switch(state) {
+		case Q921_STATE_TEI_UNASSIGNED:
+			if(Q921_IS_PTMP_TE(trunk)) {
+				res = Q921TeiSendAssignRequest(trunk);
+			}
+			break;
+
+		case Q921_STATE_TEI_ASSIGNED:
+			if(Q921_IS_PTMP_NT(trunk)) {
+				res = Q921TeiSendRemoveRequest(trunk, Q921_TEI_BCAST);
+			}
+			break;
+
+		default:
+			break;
            }
+		break;
+
+
+	case Q921_STATE_TEI_AWAITING:
+	case Q921_STATE_TEI_ESTABLISH:
+	case Q921_STATE_TEI_UNASSIGNED:
+
+		switch(state) {
+		case Q921_STATE_TEI_ASSIGNED:
+			/* establish data link */
+			if(Q921_IS_PTMP_TE(trunk)) {		/* TODO: bad hack, Layer3 is responsible for requesting DL establishment */
+				res = Q921EstablishDataLink(trunk, trunk->tei);
+
+				/* go directly into AWAITING ESTABLISHMENT state */
+				state = Q921_STATE_AWAITING_ESTABLISHMENT;
+
+				Q921Log(trunk, Q921_LOG_DEBUG, "Forcing \"%s\" (%d) state\n", Q921State2Name(state), state);
+			}
+			break;
+
+		default:
+			break;
         }
+		break;
 
-        /* check for RR */
-        else if(mes[2] ==0x01)
+
+	case Q921_STATE_TEI_ASSIGNED:
+	case Q921_STATE_AWAITING_ESTABLISHMENT:
+	case Q921_STATE_AWAITING_RELEASE:
+		/* do nothing */
+		break;
+
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+
+		/*  auto-reconnect data-layer link */
+		switch(state) {
+		case Q921_STATE_TEI_ASSIGNED:
+			/* establish data link */
+			if(Q921_IS_PTMP_TE(trunk)) {		/* TODO: bad hack, Layer3 is responsible for requesting DL establishment */
+				res = Q921EstablishDataLink(trunk, trunk->tei);
+
+				/* go directly into AWAITING ESTABLISHMENT state */
+				state = Q921_STATE_AWAITING_ESTABLISHMENT;
+
+				Q921Log(trunk, Q921_LOG_DEBUG, "Forcing \"%s\" (%d) state\n", Q921State2Name(state), state);
+			}
+			break;
+
+		default:
+			break;
+		}
+		break;
+	}
+
+	trunk->state = state;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Q921ChangeState() returns %d, new state is \"%s\" (%d)\n", res, Q921State2Name(state), state);
+
+	return res;
+}
+
+/*
+ * TEI Management functions
+ */
+static int Q921TeiSend(L2TRUNK trunk, L2UCHAR type, L2USHORT ri, L2UCHAR ai)
 		{
-			if (((mes[0]>>1)&0x01) == (trunk->NetUser == Q921_TE ? 1 : 0)) { /* if this is a command */
-				Q921SendRR(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01, mes[1]>>1, mes[2]&0x01);
+	L2UCHAR mes[10];
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR cr;
+
+	switch(type) {
+	case Q921_TEI_ID_CHECKRESP:
+	case Q921_TEI_ID_DENIED:
+	case Q921_TEI_ID_ASSIGNED:
+		cr = Q921_RESPONSE(trunk);
+		break;
+
+	default:
+		cr = Q921_COMMAND(trunk);
+		break;
 			}
 
+	mes[offset++] = Q921_LAYER_ENT_ID_TEI;	/* layer management entity identifier */
+	mes[offset++] = (ri & 0xff00) >> 8;	/* reference number upper part */
+	mes[offset++] =  ri & 0xff;		/* reference number lower part */
+	mes[offset++] = type;			/* message type: Identity Request */
+	mes[offset++] = ai << 1 | 0x01;		/* action indicator: TEI */
+
+	return Q921SendU(trunk, Q921_SAPI_TEI, cr, Q921_TEI_BCAST, 0, 0x00, mes, offset);
         }
 		
-        /* check for RNR */
-        /* check for REJ */
-        /* check for SABME */
-        else if((mes[2] & 0xef) == 0x6f)
+
+/**
+ * Q921TeiSendAssignRequest
+ * \brief	Ask for new TEI (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success, <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendAssignRequest(L2TRUNK trunk)
         {
-            Q921ProcSABME(trunk, mes, rs);
-            Q921SendUA(trunk, (mes[0]&0xfc)>>2, (mes[0]>>1)&0x01,mes[1]>>1, (mes[2]&0x10)>>4);
+	L2INT res;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* only ptmp te mode*/
+		return 0;
+
+	trunk->ri[0] = (L2USHORT)(random() % 0xffff);
+
+	/* send TEI assign request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_REQUEST, trunk->ri[0], Q921_TEI_BCAST);
+
+	/* start T202 */
+	Q921T202TimerStart(trunk);
+
+	return res;
         }
 
-        /* check for DM */
-        /* check for UI */
-        /* check for DISC */
-        /* check for UA */
-        /* check for FRMR */
-        /* check for XID */
 
-        else
+/**
+ * Q921TeiProcessAssignResponse
+ * \brief	Process assign response (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcAssignResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
         {
-            /* what the ? Issue an error */
-			/* Q921ErrorProc(trunk, Q921_UNKNOWNFRAME, mes, rs); */
-            /* todo: REJ or FRMR */
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2USHORT ri = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* PTMP TE only */
+		return 0;
+
+	ri = (mes[offset + 1] << 8) | mes[offset + 2];
+
+	if(ri != trunk->ri[0]) {
+		/* hmmm ..., not our response i guess */
+		return 0;
         }
 
-        MFIFOKillNext(trunk->HDLCInQueue);
+	switch(mes[offset + 3]) {
+	case Q921_TEI_ID_ASSIGNED:
+		/* Yay, use the new TEI and change state to assigned */
+		trunk->tei      = mes[offset + 4] >> 1;
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "Assigned TEI %d, setting state to TEI_ASSIGNED\n", trunk->tei);
+
+		Q921ChangeState(trunk, Q921_STATE_TEI_ASSIGNED);
+		break;
+
+	case Q921_TEI_ID_DENIED:
+		/* oops, what to do now? */
+		if ((mes[offset + 4] >> 1) == 127) {
+			/* No more free TEIs? this is bad */
+
+			//Q921TeiSendVerifyRequest(trunk, Q921_TEI_BCAST); /* TODO: does this work ?? */
+		} else {
+			/* other reason, this is fatal, shutdown link */
+		}
+
+		Q921Log(trunk, Q921_LOG_DEBUG, "TEI assignment has been denied, reason: %s\n",
+			 ((mes[offset +4] >> 1) == Q921_TEI_BCAST) ? "No free TEIs available" : "Unknown");
+
+		Q921ChangeState(trunk, Q921_STATE_TEI_UNASSIGNED);
+		break;
+
+	default:
+		return 0;
+	}
+
+	/* stop T202 */
+	Q921T202TimerStop(trunk);
 
         return 1;
     }
+
+
+/**
+ * Q921TeiSendVerifyRequest
+ * \brief	Verify TEI (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendVerifyRequest(L2TRUNK trunk)
+{
+	L2INT res;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* only ptmp te mode*/
+		return 0;
+
+	/* Request running? */
+	if (trunk->T202)
+		return 0;
+
+	/* Send TEI verify request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_VERIFY, trunk->ri[0], trunk->tei);
+
+	/* start T202 */
+	Q921T202TimerStart(trunk);
+
+	return res;
+}
+
+
+/**
+ * Q921TeiProcCheckRequest
+ * \brief	Process Check Request (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcCheckRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = (mes[offset + 4] >> 1);		/* action indicator => tei */
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* ptmp te mode only */
+		return 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Received TEI Check request for TEI %d\n", tei);
+
+	if (tei == Q921_TEI_BCAST || tei == trunk->tei) {
+		/*
+		 * Broadcast TEI check or for our assigned TEI
+		 */
+
+		/* send TEI check reponse */
+		res = Q921TeiSend(trunk, Q921_TEI_ID_CHECKRESP, trunk->ri[0], trunk->tei);
+
+		Q921T202TimerStop(trunk);
+	}
+
+	return res;
+}
+
+
+/**
+ * Q921TeiProcRemoveRequest
+ * \brief	Process remove Request (TE mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcRemoveRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = (mes[offset + 4] >> 1);		/* action indicator => tei */
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_TE(trunk))	/* ptmp te mode only */
     return 0;
+
+	Q921Log(trunk, Q921_LOG_DEBUG, "Received TEI Remove request for TEI %d\n", tei);
+
+	if (tei == Q921_TEI_BCAST || tei == trunk->tei) {
+		/*
+		 * Broadcast TEI remove or for our assigned TEI
+		 */
+
+		/* reset tei */
+		trunk->tei = 0;
+
+		/* change state (no action) */
+		Q921ChangeState(trunk, Q921_STATE_TEI_UNASSIGNED);
+
+		/* TODO: hmm, request new one ? */
+		res = Q921TeiSendAssignRequest(trunk);
+	}
+	return res;
 }
 
+
+/**
+ * Q921TeiProcAssignRequest
+ * \brief	Process assign request from peer (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcAssignRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	/* todo: process message */
+	return 0;
+}
+
+/**
+ * Q921TeiSendCheckRequest
+ * \brief	Send check request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to check
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+#ifdef __UNUSED__
+static int Q921TeiSendCheckRequest(L2TRUNK trunk, L2UCHAR tei)
+{
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	/* send TEI check request */
+	res = Q921TeiSend(trunk, Q921_TEI_ID_CHECKREQ, 0, tei);
+
+	/* Start NT timer, todo: this one is probably per TEI too */
+	Q921T201TimerStart(trunk, tei);
+
+	return res;
+}
+#endif
+
+/**
+ * Q921TeiProcCheckResponse
+ * \brief	Process Check Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcCheckResponse(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR resp[25];
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2USHORT ri = 0;
+	L2UCHAR tei = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT mode only */
+		return 0;
+
+	ri  = (mes[offset + 1] << 8) | mes[offset + 2];
+	tei =  mes[offset + 4] >> 1;
+
+	/* todo: handle response... check assigned TEI(s) */
+	resp[offset + 0] = 0;
+
+	return 0;
+}
+
+
+/**
+ * Q921TeiProcVerifyRequest
+ * \brief	Process Verify Request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiProcVerifyRequest(L2TRUNK trunk, L2UCHAR *mes, L2INT size)
+{
+	L2UCHAR resp[25];
+	L2UCHAR offset = Q921_UFRAME_DATA_OFFSET(trunk);
+	L2UCHAR tei = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT mode only */
+		return 0;
+
+	tei = mes[offset + 4] >> 1;
+
+	/* todo: handle response... verify assigned TEI */
+	resp[offset + 0] = 0;
+
+	return 0;
+}
+
+/**
+ * Q921TeiSendDenyResponse
+ * \brief	Send Deny Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+#ifdef __UNUSED__
+static int Q921TeiSendDenyResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri)
+{
+	L2INT res = 0;
+
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_DENIED, ri, tei);
+}
+
+
+/**
+ * Q921TeiSendAssignedResponse
+ * \brief	Send Assigned Response (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to assign
+ * \param[in]	ri	RI of request
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendAssignedResponse(L2TRUNK trunk, L2UCHAR tei, L2USHORT ri)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_ASSIGNED, ri, tei);
+}
+#endif
+
+/**
+ * Q921TeiSendRemoveRequest
+ * \brief	Send Remove Request (NT mode only)
+ * \param[in]	trunk	pointer to Q921 data struct
+ * \param[in]	tei	TEI to remove
+ * \return	> 0 on success; <= 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921TeiSendRemoveRequest(L2TRUNK trunk, L2UCHAR tei)
+{
+	if (!Q921_IS_PTMP_NT(trunk))	/* PTMP NT only */
+		return 0;
+
+	return Q921TeiSend(trunk, Q921_TEI_ID_REMOVE, 0, tei);
+}
Index: src/isdn/Q931.c
===================================================================
--- src/isdn/Q931.c	(revision 495)
+++ src/isdn/Q931.c	(working copy)
@@ -36,6 +36,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 *****************************************************************************/
 
+#include "Q921.h"
 #include "Q931.h"
 #include "national.h"
 #include "DMS.h"
@@ -93,8 +94,7 @@
 
 *****************************************************************************/
 
-Q931ErrorCB_t Q931ErrorProc;
-                                    /* callback for error messages.         */
+Q931ErrorCB_t Q931ErrorProc;			/* callback for error messages.         */
 
 L3ULONG (*Q931GetTimeProc) (void) = NULL; /* callback for func reading time in ms */
 
@@ -331,15 +331,21 @@
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT Size)
+L3INT Q931Rx23(Q931_TrunkInfo_t *pTrunk, L3INT ind, L3UCHAR * buf, L3INT Size)
 {
-    L3UCHAR *Mes = &buf[Q931L2HeaderSpace];
+	L3UCHAR *Mes = buf;
     L3INT RetCode = Q931E_NO_ERROR;
     Q931mes_Generic *m = (Q931mes_Generic *) pTrunk->L3Buf;
     L3INT ISize;
+	L3INT IOff = Q931L2HeaderSpace;
 
-    L3INT IOff = 0;
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Received message from Q.921 (%d) size: %d\n", ind, Size);
 
+	switch(ind) {
+	case Q921_DL_UNIT_DATA:		/* DL-UNITDATA indication (UI frame, 3 byte header) */
+		IOff = 3;
+
+	case Q921_DL_DATA:		/* DL-DATA indication (I frame, 4 byte header) */
     /* Protocol Discriminator */
     m->ProtDisc = Mes[IOff++];
 
@@ -350,15 +356,17 @@
     /* Message Type */
     m->MesType = Mes[IOff++];
 
-    /* Call table proc to unpack codec message */
-    /*debug */
-    /* printf("\n\nQ931Rx23-  Dialect: %d, MsgType: %d\n",pTrunk->Dialect,m->MesType); */
-    RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, Q931L4HeaderSpace + IOff , Size - Q931L4HeaderSpace - IOff + 1);
+		RetCode = Q931Umes[pTrunk->Dialect][m->MesType](pTrunk, Mes, (Q931mes_Generic *)pTrunk->L3Buf, IOff, Size - IOff + 1);
 
     if(RetCode >= Q931E_NO_ERROR)
     {
         RetCode = Q931Proc[pTrunk->Dialect][m->MesType](pTrunk, pTrunk->L3Buf, 2);
     }
+		break;
+
+	default:
+		break;
+	}
 
     return RetCode;
 }
@@ -378,6 +386,8 @@
 *****************************************************************************/
 L3INT Q931Tx34(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
 {
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending message to Layer4 (size: %d)\n", Size);
+
     if (pTrunk->Q931Tx34CBProc) {
         return pTrunk->Q931Tx34CBProc(pTrunk->PrivateData34, Mes, Size);
     }
@@ -401,18 +411,17 @@
 L3INT Q931Rx43(Q931_TrunkInfo_t *pTrunk,L3UCHAR * buf, L3INT Size)
 {
     Q931mes_Header *ptr = (Q931mes_Header*)&buf[Q931L4HeaderSpace];
-    L3INT RetCode = Q931E_NO_ERROR;
 
-    RetCode=Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk,buf,4);
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Receiving message from Layer4 (size: %d)\n", Size);
 
-    return RetCode;
+	return Q931Proc[pTrunk->Dialect][ptr->MesType](pTrunk,buf,4);;
 }
 
 /*****************************************************************************
 
-  Function:     Q931Tx32
+  Function:     Q931Tx32Data
 
-  Description:  Called from the stack to send a message to L2. The input is 
+  Description:  Called from the stack to send a DL-DATA message to L2. The input is 
                 always a non-packed message so it will first make a proper
                 call to create a packed message before it transmits that
                 message to layer 2.
@@ -425,19 +434,21 @@
                 see q931errors.h for details.
 
 *****************************************************************************/
-L3INT Q931Tx32(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
+L3INT Q931Tx32Data(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
 {
-    L3INT     OSize;
     Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
     L3INT RetCode = Q931E_NO_ERROR;
     L3INT iDialect = pTrunk->Dialect;
+	L3INT OSize;
+
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending DL-DATA request message to Q.921 (size: %d)\n", Size);
 
     /* Call pack function through table. */
     RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace], &OSize);
     if(RetCode >= Q931E_NO_ERROR)
     {
         if (pTrunk->Q931Tx32CBProc) {
-            RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, pTrunk->L2Buf, OSize + Q931L2HeaderSpace);
+			RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, Q921_DL_DATA, pTrunk->L2Buf, OSize + Q931L2HeaderSpace);
         } else {
             RetCode = Q931E_MISSING_CB;
         }
@@ -446,6 +457,32 @@
     return RetCode;
 }
 
+/**
+ * Q931Tx32UnitData
+ * \brief	Used to send a DL-UNIT DATA Request to Layer2
+ */
+L3INT Q931Tx32UnitData(Q931_TrunkInfo_t *pTrunk, L3UCHAR * Mes, L3INT Size)
+{
+	Q931mes_Generic *ptr = (Q931mes_Generic*)Mes;
+	L3INT RetCode = Q931E_NO_ERROR;
+	L3INT iDialect = pTrunk->Dialect;
+	L3INT OSize;
+
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Sending DL-UNIT DATA request message to Q.921 (size: %d)\n", Size);
+
+	/* Call pack function through table. */
+	RetCode = Q931Pmes[iDialect][ptr->MesType](pTrunk, (Q931mes_Generic *)Mes, Size, &pTrunk->L2Buf[Q931L2HeaderSpace-1], &OSize);
+	if(RetCode >= Q931E_NO_ERROR)
+	{
+		if (pTrunk->Q931Tx32CBProc) {
+			RetCode = pTrunk->Q931Tx32CBProc(pTrunk->PrivateData32, Q921_DL_UNIT_DATA, pTrunk->L2Buf, OSize + Q931L2HeaderSpace - 1);
+		} else {
+			RetCode = Q931E_MISSING_CB;
+		}
+	}
+
+	return RetCode;
+}
 
 /*****************************************************************************
 
@@ -757,3 +794,51 @@
 }
 
 
+/*
+ * Logging
+ */
+#include <stdarg.h>
+
+L3INT Q931Log(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level, const char *fmt, ...)
+{
+	char  buf[Q931_LOGBUFSIZE];
+	L3INT len;
+	va_list ap;
+
+	if(!trunk->Q931LogCBProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, sizeof(buf)-1, fmt, ap);
+	if(len <= 0) {
+		/* TODO: error handling */
+		return -1;
+	}
+
+	va_end(ap);
+
+	return trunk->Q931LogCBProc(trunk->PrivateDataLog, level, buf, strnlen(buf, sizeof(buf)-1));
+}
+
+/**
+ * Q921SetLogCB
+ * \brief	Set Logging callback function and private data
+ */
+void Q931SetLogCB(Q931_TrunkInfo_t *trunk, Q931LogCB_t func, void *priv)
+{
+	trunk->Q931LogCBProc = func;
+	trunk->PrivateDataLog = priv;
+}
+
+/**
+ * Q921SetLogLevel
+ * \brief	Set Loglevel
+ */
+void Q931SetLogLevel(Q931_TrunkInfo_t *trunk, Q931LogLevel_t level)
+{
+	trunk->loglevel = level;
+}
Index: src/include/zap_types.h
===================================================================
--- src/include/zap_types.h	(revision 495)
+++ src/include/zap_types.h	(working copy)
@@ -117,11 +117,12 @@
 	ZAP_TRUNK_T1,
 	ZAP_TRUNK_J1,
 	ZAP_TRUNK_BRI,
+	ZAP_TRUNK_BRI_PTMP,
 	ZAP_TRUNK_FXO,
 	ZAP_TRUNK_FXS,
 	ZAP_TRUNK_NONE
 } zap_trunk_type_t;
-#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "FXO", "FXS", "NONE"
+#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "BRI_PTMP", "FXO", "FXS", "NONE"
 ZAP_STR2ENUM_P(zap_str2zap_trunk_type, zap_trunk_type2str, zap_trunk_type_t)
 
 typedef enum {
